﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;

namespace MongoDbConsole
{
    public class Category
    {
        private IList<Product> _products = new List<Product>(); 

        public string Name { get; set; }

        public IList<Product> Products
        {
            get
            {
                return new ReadOnlyCollection<Product>(_products); 
            }

            set { _products = value; }
        }

        public void AddProducts(List<Product> products)
        {
            foreach(var product in products)
            {
                AddProduct(product); 
            }
        }

        public void AddProduct(Product product)
        {
            _products.Add(product); 
        }
    }
}
