﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using MongoDB.Driver;

namespace MongoDbConsole
{
    public class DocumentConvertor
    {
        private Document _document; 

        public Document GetChildDocumentFromList(IEnumerable list)
        {
            var enumerator = list.GetEnumerator();

            while (enumerator.MoveNext())
            {
                if (enumerator.Current != null)
                    ConvertFrom(enumerator.Current);
            }

            return null; 
        }

        public Document ConvertFrom<T>(T source) 
        {
            if(_document == null)
                _document = new Document(); 

            var properties = source.GetType().GetProperties(BindingFlags.Instance | BindingFlags.Public);

            foreach (var property in properties)
            {
                // add the property value to the document 
                _document[property.Name] = property.GetValue(source, null);
               
                if (property.PropertyType.IsGenericType
                    && property.PropertyType.GetGenericTypeDefinition().Equals(typeof(List<>)))
                {
                    // get the property value which will be a list 

                   // document.Append(property.Name,// new document that )
                    
                   _document[property.Name] = property.Name; 

                    var list = property.GetValue(source, null) as IEnumerable;

                    var enumerator = list.GetEnumerator();

                    while (enumerator.MoveNext())
                    {
                        if (enumerator.Current != null)
                            ConvertFrom(enumerator.Current);
                    }
                }
            }

            return _document; 
        }
    }
}
